//+------------------------------------------------------------------+
//|                                                 Blau_Ergodic.mq5 |
//|                        Copyright 2011, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2011, MetaQuotes Software Corp." //  -
#property link      "http://www.mql5.com"                       //    -
#property description "Ergodic Oscillator (William Blau)"       //   mql5-
#include <WilliamBlau.mqh>                 //   (   )
//---  
#property indicator_separate_window        //     
#property indicator_buffers 11             //     
#property indicator_plots   2              //     
//---  
#property indicator_level1 -25             //   #0   
#property indicator_level2 25              //   #1   
#property indicator_levelcolor Silver      //     
#property indicator_levelstyle STYLE_DOT   //   : STYLE_DOT -  
#property indicator_levelwidth 1           //   
//---     
#property indicator_minimum -100           //      
#property indicator_maximum 100            //      
//---   #0 (Main)
#property indicator_label1  "Ergodic"      //     #0
#property indicator_type1   DRAW_HISTOGRAM // : DRAW_HISTOGRAM -    
#property indicator_color1  Silver         //    : Silver - 
#property indicator_style1  STYLE_SOLID    //  : STYLE_SOLID -  
#property indicator_width1  2              //  
//---   #1 (Signal Line)
#property indicator_label2  "Signal"       //     #1
#property indicator_type2   DRAW_LINE      // : DRAW_LINE - 
#property indicator_color2  Red            //    : Red - 
#property indicator_style2  STYLE_SOLID    //  : STYLE_SOLID -  
#property indicator_width2  1              //  
//---  
input int    q=2;  // q - ,    
input int    r=20; // r -  1- EMA,   
input int    s=5;  // s -  2- EMA,     
input int    u=3;  // u -  3- EMA,     
input int    ul=3; // ul - ( )  EMA,   
input ENUM_APPLIED_PRICE AppliedPrice=PRICE_CLOSE; // AppliedPrice -  
//---     
double MainBuffer[];        //  (   #0)
double SignalBuffer[];      //  : ul- EMA   (   #1)
double PriceBuffer[];       //  
double MtmBuffer[];         // q- 
double EMA_MtmBuffer[];     // r- 1- EMA
double DEMA_MtmBuffer[];    // s- 2- EMA
double TEMA_MtmBuffer[];    // u- 3- EMA
double AbsMtmBuffer[];      // q-  ( )
double EMA_AbsMtmBuffer[];  // r- 1- EMA ( )
double DEMA_AbsMtmBuffer[]; // s- 2- EMA ( )
double TEMA_AbsMtmBuffer[]; // u- 3- EMA ( )
//---  
int    begin1, begin2, begin3, begin4, begin5; //  ,     
int    rates_total_min; //     
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---        
   //   ;     
   //   #0
   SetIndexBuffer(0,MainBuffer,INDICATOR_DATA);                 // 
   //   #1
   SetIndexBuffer(1,SignalBuffer,INDICATOR_DATA);               //  : ul- EMA  
   //     ;    
   SetIndexBuffer(2,PriceBuffer,INDICATOR_CALCULATIONS);        //  
   SetIndexBuffer(3,MtmBuffer,INDICATOR_CALCULATIONS);          // q- 
   SetIndexBuffer(4,EMA_MtmBuffer,INDICATOR_CALCULATIONS);      // r- 1- EMA
   SetIndexBuffer(5,DEMA_MtmBuffer,INDICATOR_CALCULATIONS);     // s- 2- EMA
   SetIndexBuffer(6,TEMA_MtmBuffer,INDICATOR_CALCULATIONS);     // u- 3- EMA
   SetIndexBuffer(7,AbsMtmBuffer,INDICATOR_CALCULATIONS);       // q-  ( )
   SetIndexBuffer(8,EMA_AbsMtmBuffer,INDICATOR_CALCULATIONS);   // r- 1- EMA ( )
   SetIndexBuffer(9,DEMA_AbsMtmBuffer,INDICATOR_CALCULATIONS);  // s- 2- EMA ( )
   SetIndexBuffer(10,TEMA_AbsMtmBuffer,INDICATOR_CALCULATIONS); // u- 3- EMA ( )
/*
//---   #0 (Main)
   PlotIndexSetString(0,PLOT_LABEL,"Ergodic");           //     #0
   PlotIndexSetInteger(0,PLOT_DRAW_TYPE,DRAW_HISTOGRAM); // : DRAW_HISTOGRAM -    
   PlotIndexSetInteger(0,PLOT_LINE_COLOR,Silver);        //    : Silver - 
   PlotIndexSetInteger(0,PLOT_LINE_STYLE,STYLE_SOLID);   //  : STYLE_SOLID -  
   PlotIndexSetInteger(0,PLOT_LINE_WIDTH,2);             //  
//---   #1 (Signal Line)
   PlotIndexSetString(1,PLOT_LABEL,"Signal");            //     #1
   PlotIndexSetInteger(1,PLOT_DRAW_TYPE,DRAW_LINE);      // : DRAW_LINE - 
   PlotIndexSetInteger(1,PLOT_LINE_COLOR,Red);           //    : Red - 
   PlotIndexSetInteger(1,PLOT_LINE_STYLE,STYLE_SOLID);   //  : STYLE_SOLID -  
   PlotIndexSetInteger(1,PLOT_LINE_WIDTH,1);             //  
*/
//---    
   IndicatorSetInteger(INDICATOR_DIGITS,2);
/*
//---  
   IndicatorSetInteger(INDICATOR_LEVELS,2);                //     
   IndicatorSetDouble(INDICATOR_LEVELVALUE,0,-25);         //   #0   
   IndicatorSetDouble(INDICATOR_LEVELVALUE,1,25);          //   #1   
   IndicatorSetInteger(INDICATOR_LEVELCOLOR,Silver);       //     
   IndicatorSetInteger(INDICATOR_LEVELSTYLE,STYLE_DOT);    //   : STYLE_DOT -  
   IndicatorSetInteger(INDICATOR_LEVELWIDTH,1);            //   
   IndicatorSetString(INDICATOR_LEVELTEXT,0,"Oversold");   //   #0 ""
   IndicatorSetString(INDICATOR_LEVELTEXT,1,"Overbought"); //   #1 ""
//---     
   IndicatorSetDouble(INDICATOR_MINIMUM,-100); //      
   IndicatorSetDouble(INDICATOR_MAXIMUM,100);  //      
*/
//---
   begin1=q-1;         //                                    -  : MtmBuffer[], AbsMtmBuffer[]
   begin2=begin1+r-1;  // or =(q-1)+(r-1)                    -  : EMA_...[]
   begin3=begin2+s-1;  // or =(q-1)+(r-1)+(s-1)              -  : DEMA_...[]
   begin4=begin3+u-1;  // or =(q-1)+(r-1)+(s-1)+(u-1)        -  : TEMA_...[], MainBuffer[]
   begin5=begin4+ul-1; // or =(q-1)+(r-1)+(s-1)+(u-1)+(ul-1) -  : SignalBuffer[]
   //
   rates_total_min=begin5+1; //     
//---        #0
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,begin4);
//---        #1
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,begin5);
//---   
   string shortname=PriceName(AppliedPrice)+","+string(q)+","+string(r)+","+string(s)+","+string(u)+","+string(ul);
   IndicatorSetString(INDICATOR_SHORTNAME,"Blau_Ergodic("+shortname+")");
//--- OnInit done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(
                const int rates_total,     //   
                const int prev_calculated, //     
                const datetime &Time[],    // Time
                const double &Open[],      // Open
                const double &High[],      // High
                const double &Low[],       // Low
                const double &Close[],     // Close
                const long &TickVolume[],  // Tick Volume
                const long &Volume[],      // Real Volume
                const int &Spread[]        // Spread
               )
  {
   int i,pos;
   double value1,value2;
//---      
   if(rates_total<rates_total_min) return(0);
//---    PriceBuffer[]
   CalculatePriceBuffer(
                        AppliedPrice,        //  
                        rates_total,         //   
                        prev_calculated,     //     
                        Open,High,Low,Close, //  Open[], High[], Low[], Close[]
                        PriceBuffer          //   
                       );
//---  mtm  |mtm|
   //   (pos),   /  mtm  |mtm|
   //     MtmBuffer[]  AbsMtmBuffer[]
   if(prev_calculated==0)      //   
     {
      pos=begin1;              //  c  ,    
      for(i=0;i<pos;i++)       //   
        {
         MtmBuffer[i]=0.0;     //  
         AbsMtmBuffer[i]=0.0;  //
        }
     }
   else pos=prev_calculated-1; //     
   //     MtmBuffer[]  AbsMtmBuffer[]
   for(i=pos;i<rates_total;i++)
     {
      MtmBuffer[i]=PriceBuffer[i]-PriceBuffer[i-(q-1)];
      AbsMtmBuffer[i]=MathAbs(MtmBuffer[i]);
     }
//---   EMA
   // r- 1- EMA
   ExponentialMAOnBufferWB(
                           rates_total,     //   
                           prev_calculated, //     
                           begin1,          //         
                           r,               //  
                           MtmBuffer,       //  
                           EMA_MtmBuffer    //  
                          );
   ExponentialMAOnBufferWB(rates_total,prev_calculated,begin1,r,AbsMtmBuffer,EMA_AbsMtmBuffer);
   // s- 2- EMA
   ExponentialMAOnBufferWB(rates_total,prev_calculated,begin2,s,EMA_MtmBuffer,DEMA_MtmBuffer);
   ExponentialMAOnBufferWB(rates_total,prev_calculated,begin2,s,EMA_AbsMtmBuffer,DEMA_AbsMtmBuffer);
   // u- 3- EMA
   ExponentialMAOnBufferWB(rates_total,prev_calculated,begin3,u,DEMA_MtmBuffer,TEMA_MtmBuffer);
   ExponentialMAOnBufferWB(rates_total,prev_calculated,begin3,u,DEMA_AbsMtmBuffer,TEMA_AbsMtmBuffer);
//---   (   #0)
   //   (pos),   /  
   //     MainBuffer[]
   if(prev_calculated==0)      //   
     {
      pos=begin4;              //  c  ,    
      for(i=0;i<pos;i++)       //   
         MainBuffer[i]=0.0;    //  
     }
   else pos=prev_calculated-1; //     
   //     MainBuffer[]
   for(i=pos;i<rates_total;i++)
     {
      value1=100*TEMA_MtmBuffer[i];
      value2=TEMA_AbsMtmBuffer[i];
      MainBuffer[i]=(value2>0)?value1/value2:0;
     }
//---  Signal Line (   #1)
   ExponentialMAOnBufferWB(rates_total,prev_calculated,begin4,ul,MainBuffer,SignalBuffer);
//--- OnCalculate done. Return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
